Subject: Re: [RFC] New commit object headers: note headers

From: Jakub Narebski <[email-masked]>
Date: Sun, 10 Feb 2008 00:26:38 +0100

On Sat, 9 Feb 2008, Junio C Hamano wrote:
> "Nguyen Thai Ngoc Duy" <[email-masked]> writes:
>> On Sun, Feb 10, 2008 at 12:35 AM, Daniel Barkalow <[email-masked]> wrote:
>>> On Sat, 9 Feb 2008, Jakub Narebski wrote:
>>>>
>>>> 2. 'note' header (no semantical meaning)
>>>>
>>>> There was some time ago discussion about adding 'note' header, initially
>>>> to save original sha-1 of a commit for cherry-picking and rebase; then
>>>> for saving explicit rename or corrected rename info, for saving chosen
>>>> merge strategy, and for saving original ID of SCM import.
>>>
>>>  Probably want to have a prescribed syntax for specifying what note this
>>>  is, so that different programs using notes don't confuse each other.
>>
>> How about git ignoring all X- headers and let programs freely add
>> them? For example, X-SVN may be used for git-svn.
> 
> Please don't.
> 
> When two people/programs create an otherwise identical (for the
> purpose of git) commits that have two different object names,
> there'd better be a very good reason other than "I felt like
> adding an extra header that I can use willy-nilly".
> 
> Please separate the 'note' part and the 'generation' part and
> make two separate discussion threads.
> 
> And kill 'note' part altogether, but that can be done in that
> thread ;-).

Ah, well... very good reservation. So here it goes generic 'note'
(or 'X-*', similarly to non-standarized email headers) header...

Still I think it is would be nice to have original commit id in
a header when importing from foreign SCM. First, it would not pollute
commit message, which would be identical with the original commit
message (which allows easy two-way interaction). Second, it is
much easier and much less error prone to extract it by machine.

As to marking explicitely renames and copies...
-- 
Jakub Narebski
Poland